//+------------------------------------------------------------------+
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers    3
#property indicator_color1     LimeGreen
#property indicator_color2     Orange
#property indicator_color3     Orange
#property indicator_width1     2
#property indicator_width2     2
#property indicator_width3     2

//
//
//
//
//

extern int    T3Period           = 14;
extern double T3Hot              = 0.7;
extern int    T3Count            = 3;
extern int    Price              = PRICE_MEDIAN;
extern int    PriceShift         = 0;
extern int    T3Shift            = 0;
//
//
//
//
//

double buffer1[];
double buffer2[];
double buffer3[];
double slope[];


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,buffer1); SetIndexShift(0,T3Shift);
   SetIndexBuffer(1,buffer2); SetIndexShift(1,T3Shift);
   SetIndexBuffer(2,buffer3); SetIndexShift(2,T3Shift);
   SetIndexBuffer(3,slope);
      T3Count = MathMax(MathMin(T3Count,15),1);
      IndicatorShortName(" T3 smooth");
   return(0);
}

int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-1,Bars-counted_bars);
           
   //
   //
   //
   //
   //
           
   if (slope[limit]==-1) CleanPoint(limit,buffer2,buffer3);
   for (int i=limit; i>=0; i--)
   {
      double price = iMA(NULL,0,1,0,MODE_SMA,Price,i+PriceShift); if (price==0) continue;
      buffer1[i]  = iT3a(price,T3Period,T3Hot,T3Count,i);
      buffer2[i]  = EMPTY_VALUE;
      buffer3[i]  = EMPTY_VALUE;
      if (i<Bars-1)
      {
         slope[i] = slope[i+1];
         if (buffer1[i]>buffer1[i+1]) slope[i] =  1;
         if (buffer1[i]<buffer1[i+1]) slope[i] = -1;
         if (slope[i]==-1) PlotPoint(i,buffer2,buffer3,buffer1);
      }                  
   }
   return(0);
}

//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
//
//
//
//
//

double workT3a[][75];
double iT3a(double price, double period, double hot, int smooth, int r)
{
   if (ArrayRange(workT3a,0) !=Bars) ArrayResize(workT3a,Bars); r = Bars-r-1;
   
   //
   //
   //
   //
   //
   
   
   double alpha =  2.0/(1.0+period); 
   for (int i=0, k=0; i<smooth; i++, k+=3)
      if (r == 0)
      {
         workT3a[r][k+0] = price;
         workT3a[r][k+1] = price;
         workT3a[r][k+2] = price; 
      }
      else
      {
         if (k>0)
         {
            workT3a[r][k+0] = workT3a[r-1][k+0]+alpha*(workT3a[r][k-1]-workT3a[r-1][k+0]);
            workT3a[r][k+1] = workT3a[r-1][k+1]+alpha*(workT3a[r][k+0]-workT3a[r-1][k+1]);
            workT3a[r][k+2] = workT3a[r][k+0]*(1+hot)-workT3a[r][k+1]*hot;
         }
         else
         {
            workT3a[r][k+0] = workT3a[r-1][k+0]+alpha*(price            -workT3a[r-1][k+0]);
            workT3a[r][k+1] = workT3a[r-1][k+1]+alpha*(workT3a[r  ][k+0]-workT3a[r-1][k+1]);
            workT3a[r][k+2] = workT3a[r][k+0]*(1+hot)-workT3a[r][k+1]*hot;
         }            
      }
   return(workT3a[r][smooth*3-1]);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}